@ECHO OFF
IF DEFINED _debug (
   IF /I %_debug%.==trace. (
      @ECHO ON
   )
)
:: ----------------------------------------------------------------------------
:Main
:: NOTE: THis file needs to have CRLF or \r\n line endings, instead of just LF or 
:: \n line endings. Otherwise the call statements may have trouble finding the labels 
:: ----------------------------------------------------------------------------
SETLOCAL ENABLEDELAYEDEXPANSION
SET _PGM=%0
SET /A _ErrorFound=0
SET /A _WarningFound=0
IF %1.==. (
   SET _RTCDIR_ERROR=^%%1 is missing.  Please pass in the drive and RTC Directory to package, e.g. c:\RAMS\ [without the trailing backslash]
   SET /A _ErrorFound+=1
) ELSE (
   IF /I %1.==help (
      GOTO :HELP
   )
)
IF %2.==. (
   SET _RELEASENAME_ERROR=^%%2 is missing.  Please pass in the Release Name, e.g. RAMS.2.1.0
   SET /A _ErrorFound+=1
)
IF %_ErrorFound% GTR 0 GOTO :ERRORS
SET _RTCDIR=%1
SET _RELEASENAME=%2

IF EXIST !_RTCDIR!\!_RELEASENAME! (
   ECHO Removing specific subdirectories from !_RTCDIR!\!_RELEASENAME!.
   CALL :REMOVEDIRS "!_RTCDIR!\!_RELEASENAME!\ps"
   CALL :REMOVEDIRS "!_RTCDIR!\!_RELEASENAME!\Reports"
   CALL :REMOVEDIRS "!_RTCDIR!\!_RELEASENAME!\SiteAssets"
   CALL :REMOVEDIRS "!_RTCDIR!\!_RELEASENAME!\SitePages"
   CALL :REMOVEDIRS "!_RTCDIR!\!_RELEASENAME!\SQL"
   CALL :REMOVEDIRS "!_RTCDIR!\!_RELEASENAME!\Temp"
   CALL :REMOVEDIRS "!_RTCDIR!\!_RELEASENAME!\Templates"
   CALL :REMOVEDIRS "!_RTCDIR!\!_RELEASENAME!\Webapp"
   CALL :REMOVEDIRS "!_RTCDIR!\!_RELEASENAME!\_catalogs"
   ECHO Creating specific subdirectories in !_RTCDIR!\!_RELEASENAME!.
   MD !_RTCDIR!\!_RELEASENAME!\ps
   MD !_RTCDIR!\!_RELEASENAME!\Reports
   MD !_RTCDIR!\!_RELEASENAME!\SiteAssets\js
   MD !_RTCDIR!\!_RELEASENAME!\SitePages
   MD !_RTCDIR!\!_RELEASENAME!\SQL
   MD !_RTCDIR!\!_RELEASENAME!\Temp
   MD !_RTCDIR!\!_RELEASENAME!\Templates
   MD !_RTCDIR!\!_RELEASENAME!\Webapp\!_RELEASENAME!
   MD "!_RTCDIR!\!_RELEASENAME!\_catalogs\masterpage\RAMS MasterpageTemplate\css"
   MD "!_RTCDIR!\!_RELEASENAME!\_catalogs\masterpage\RAMS MasterpageTemplate\fonts"
   MD "!_RTCDIR!\!_RELEASENAME!\_catalogs\masterpage\RAMS MasterpageTemplate\img"
   MD "!_RTCDIR!\!_RELEASENAME!\_catalogs\masterpage\RAMS MasterpageTemplate\js"
) else (
   :: MD creates all directories in in the path if they do not exist.
   ECHO Creating specific subdirectories in !_RTCDIR!\!_RELEASENAME!.
   MD !_RTCDIR!\!_RELEASENAME!\ps
   MD !_RTCDIR!\!_RELEASENAME!\Reports
   MD !_RTCDIR!\!_RELEASENAME!\SiteAssets\js
   MD !_RTCDIR!\!_RELEASENAME!\SitePages
   MD !_RTCDIR!\!_RELEASENAME!\SQL
   MD !_RTCDIR!\!_RELEASENAME!\Temp
   MD !_RTCDIR!\!_RELEASENAME!\Templates
   MD !_RTCDIR!\!_RELEASENAME!\Webapp\!_RELEASENAME!
   MD "!_RTCDIR!\!_RELEASENAME!\_catalogs\masterpage\RAMS MasterpageTemplate\css"
   MD "!_RTCDIR!\!_RELEASENAME!\_catalogs\masterpage\RAMS MasterpageTemplate\fonts"
   MD "!_RTCDIR!\!_RELEASENAME!\_catalogs\masterpage\RAMS MasterpageTemplate\img"
   MD "!_RTCDIR!\!_RELEASENAME!\_catalogs\masterpage\RAMS MasterpageTemplate\js"
)

:: Call COPYFILES passing the source destination and 1 file name filter and 1 file extension filter. File extension filter is the file extension with the leading period.
:: COPYFILES uses XCOPY flags /I to create directories if more than one file is being copied; /S to copy subdirectories; /V to verify after copying
:: /Q to not display filenames when copying; /Y to suppress prompting for confirmation on overwrite;  
CALL :COPYFILES "!_RTCDIR!\SP Powershell\R2.1" "!_RTCDIR!\!_RELEASENAME!\ps" "*" ".*" "/I /S /V /Q"
pause 
CALL :COPYFILES "!_RTCDIR!\UI\R2.1\Reports" "!_RTCDIR!\!_RELEASENAME!\Reports" "*" ".*" "/I /S /V /Q"
pause 
CALL :COPYFILES "!_RTCDIR!\UI\R2.1\SiteAssets" "!_RTCDIR!\!_RELEASENAME!\SiteAssets" "*" ".*" "/I /S /V /Q"
pause 
CALL :COPYFILES "!_RTCDIR!\UI\R2.1\SitePages" "!_RTCDIR!\!_RELEASENAME!\SitePages" "*" ".*" "/I /S /V /Q"
pause 
CALL :COPYFILES "!_RTCDIR!\SQL Server\R2.1" "!_RTCDIR!\!_RELEASENAME!\SQL" "*" ".*" "/I /S /V /Q"
pause 
CALL :COPYFILES "!_RTCDIR!\UI\R2.1\Templates" "!_RTCDIR!\!_RELEASENAME!\Templates" "*" ".*" "/I /S /V /Q"
pause 
CALL :COPYFILES "!_RTCDIR!\JAVA SOURCE" "!_RTCDIR!\!_RELEASENAME!\Webapp\!_RELEASENAME!"  "*" ".sh" "/Y /V /Q"
pause 
CALL :COPYFILES "!_RTCDIR!\PasswordHelper\target" "!_RTCDIR!\!_RELEASENAME!\Webapp\"  "RAMSPasswordHelper-*-jar-with-dependencies" ".jar" "/Y /V /Q"
pause 
CALL :COPYFILES "!_RTCDIR!\JAVA SOURCE\target" "!_RTCDIR!\!_RELEASENAME!\Webapp\!_RELEASENAME!"  "RAMS-2.1.0*" ".war" "/Y /V /Q"
pause 
CALL :COPYFILES "!_RTCDIR!\JAVA SOURCE\target\RAMS-2.1.0\WEB-INF\lib" "!_RTCDIR!\!_RELEASENAME!\Webapp\!_RELEASENAME!"  "commons-codec-1.9" ".jar" "/Y /V /Q"
pause 
CALL :COPYFILES "!_RTCDIR!\JAVA SOURCE" "!_RTCDIR!\!_RELEASENAME!\Webapp\!_RELEASENAME!"  "RAMS-2.1.0*" ".xml" "/Y /V /Q"
pause 
CALL :COPYFILES "!_RTCDIR!\JAVA SOURCE\jce" "!_RTCDIR!\!_RELEASENAME!\Webapp\!_RELEASENAME!"  "jce_policy-*" "" "/I /S /V /Q"
pause 
CALL :COPYFILES "!_RTCDIR!\UI\R2.1\_catalogs" "!_RTCDIR!\!_RELEASENAME!\_catalogs" "*" ".*" "/I /S /V /Q /Y"


GOTO :END
:: ----------------------------------------------------------------------------
:REMOVEDIRS
:: ----------------------------------------------------------------------------
::SETLOCAL
SET _DIR=%1
CALL :ALTDEQUOTE _DIR
IF EXIST !_DIR! (
   ECHO Removing directory !_DIR! and all subdirectories
  RD /S /Q !_DIR!
)
 
GOTO :EOF

:: ----------------------------------------------------------------------------
:COPYFILES
:: ----------------------------------------------------------------------------
::SETLOCAL 
IF DEFINED _Debug ECHO --- ENTERING COPYFILES ---------------------------------
IF DEFINED _Debug ECHO 0=%0 1=%1 2=%2 3=%3 4=%5 6=%6 7=%7 8=%8 9=%9
SET _SOURCEDIR=%1
CALL :ALTDEQUOTE _SOURCEDIR
SET _DESTDIR=%2
CALL :ALTDEQUOTE _DESTDIR
SET _FILENAME=%3
CALL :ALTDEQUOTE _FILENAME
SET _EXT=%4
CALL :ALTDEQUOTE _EXT
SET _FLAGS=%5
CALL :ALTDEQUOTE _FLAGS

IF DEFINED _Debug ECHO _SOURCEDIR=!_SOURCEDIR! _DESTDIR=!_DESTDIR! _FILENAME=!_FILENAME! _EXT=!_EXT! _FLAGS=!_FLAGS!
IF EXIST "!_SOURCEDIR!" (
    SET _COMMAND=XCOPY "!_SOURCEDIR!\!_FILENAME!!_EXT!" "!_DESTDIR!\." !_FLAGS! 
    ECHO Running Command: !_COMMAND!
	!_COMMAND!
) ELSE (
	ECHO "ERROR: can't find source directory !_SOURCEDIR!"
	SET /A _ErrorFound+=1
)
IF DEFINED _Debug ECHO --- LEAVING COPYFILES ---- "!_DESTDIR!" -----------------------------
GOTO :EOF

::---------------------------------------------------------------------------------------
:ALTDEQUOTE
IF DEFINED _Debug ECHO    ----- ENTERING ALTDEQUOTE: ^|%*^| -----
::---------------------------------------------------------------------------------------
:: A routine that will reliably remove quotes from a variable's contents.
::
::  This routine will only affects items that both begin AND end with 
::  a double quote. 
::  e.g. will turn "C:\Program Files\somefile.txt"  
::       into       C:\Program Files\somefile.txt 
::  while still preserving cases such as  Height=5'6" and Symbols="!@#
::
:: Removes the outer set of double quotes from a variable.
:: Written by Frank P. Westlake, 2001.09.22, 2001.09.24
:: Modified by Simon Sheppard 2002.06.09
::
:: Usage as a function within a script:
::   CALL :ALTDeQuote VariableName
::
:: Calling as a function from another batch file:
::   CALL ALTDeQuote.cmd VariableName
::
:: If the first and last characters of the variable contents are double
:: quotes then they will be removed. This function preserves cases such as
::   Set Height=5'6" and Set Symbols="!@#
::
:: If a variable is quoted twice and has delimiters then you will 
:: need to run the function twice to remove both sets.
::   Set var=""Two Quotes;And,Delimiters=Fails""
::
:: If the variable name itself contains spaces the routine will fail
:: e.g. %v_my_variable% rather than %my variable%
::---------------------------------------------------------------------------------------
::IF DEFINED _Debug ECHO 0=%0 1=%1 2=%2 3=%3 4=%5 6=%6 7=%7 8=%8 9=%9
::IF DEFINED _Debug ECHO *=%* 
::PAUSE
:: save the name of the variable passed in
SET _dequote.variable=%1
::IF DEFINED _Debug ECHO %0: ^|%1^|%_dequote.variable%^|!_dequote.variable!^|

:: get the contents of the varianle
::IF DEFINED _Debug ECHO _dequote.contents=%%!_dequote.variable!%%
CALL SET _dequote.contents=%%!_dequote.variable!%%
::IF DEFINED _Debug ECHO !_dequote.variable!=!_dequote.contents!

IF [!_dequote.contents:~0^,1!]==[^"] (
   IF [!_dequote.contents:~-1!]==[^"] (
      SET _dequote.contents=!_dequote.contents:~1,-1!
   ) ELSE (
      :: no end quote
      GOTO :ADQFinalize )
) ELSE (
   :: no beginning quote
   GOTO :ADQFinalize )
::IF DEFINED _Debug ECHO !_dequote.variable!=!_dequote.contents!
SET !_dequote.variable!=!_dequote.contents!
REM SET _dequote.variable=
REM SET _dequote.contents=

:ADQFinalize
SET _item=!_dequote.contents!
IF DEFINED _Debug ECHO    ----- LEAVING ALTDEQUOTE: ^|_dequote.variable=!_dequote.variable! _dequote.contents=!_dequote.contents! item=!_item!^| -----
GOTO :EOF
 
:: ----------------------------------------------------------------------------
:ERRORS
:: ----------------------------------------------------------------------------
ECHO.
IF "%_RTCDIR_ERROR%". NEQ "". (
   ECHO %_RTCDIR_ERROR%
)
IF "%_ReleaseName_ERROR%". NEQ "". (
   ECHO %_ReleaseName_ERROR%
)
ECHO.
GOTO :HELP
:: ----------------------------------------------------------------------------
:END
:: ----------------------------------------------------------------------------
ENDLOCAL
GOTO :EOF
:: ----------------------------------------------------------------------------
:HELP
:: Display program syntax help here.  
:: ----------------------------------------------------------------------------
ECHO *** %_PGM% HELP ***
ECHO ***
ECHO ***  SYNTAX: %_PGM% ^<RTC Directory^> ^<ReleaseName^>
ECHO ***
ECHO ***   USAGE: This program is used create the development directories in the format
ECHO ***          ^<RTC Directory^>\^<ReleaseName^>
ECHO ***
ECHO *** EXAMPLE: %_PGM% C:\dev-projects\RAMS\relx RAMS-2.1.0
ECHO ***          creates the following directories:
ECHO ***          C:\dev-projects\RAMS\relx\RAMS-2.1.0\ps
ECHO ***          C:\dev-projects\RAMS\relx\RAMS-2.1.0\SiteAssets\js
ECHO ***          C:\dev-projects\RAMS\relx\RAMS-2.1.0\SitePages
ECHO ***          C:\dev-projects\RAMS\relx\RAMS-2.1.0\SQL
ECHO ***          C:\dev-projects\RAMS\relx\RAMS-2.1.0\Reports
ECHO ***          C:\dev-projects\RAMS\relx\RAMS-2.1.0\Templates
ECHO ******
GOTO :EOF