package gov.va.rams.entities;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;

/**
 *
 * @author Brian
 */
@Entity
@Table(name = "Comments")
@XmlRootElement
@XmlAccessorType(XmlAccessType.NONE)
public class Comment implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "CommentsID")
    @XmlElement
    private Integer commentsID;
    @Basic
    @Column(name = "FormsID")
    @XmlElement
    private Integer formsID;
    @Basic
    @Column(name = "QuestionsID")
    @XmlElement
    private Integer questionsID;
    @Basic
    @Column(name = "AnswersID")
    @XmlElement
    private Integer answersID;
    @JoinColumn(name = "UsersID", referencedColumnName = "UsersID", nullable = false)
    @ManyToOne(optional = false)
    @XmlElement
    private User user;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 1073741823)
    @Column(name = "HyperText")
    @XmlElement
    private String hyperText;
    @Basic(optional = false)
    @NotNull
    @Column(name = "Published")
    @XmlElement
    private boolean published;
    @Basic(optional = false)
    @NotNull
    @Column(name = "RedFlagged")
    @XmlElement
    private boolean redFlagged;
    @Basic(optional = false)
    @NotNull
    @Column(name = "CreatedAt")
    @Temporal(TemporalType.TIMESTAMP)
    @XmlElement
    private Date createdAt;
    @JoinColumn(name = "StudyStatusID", referencedColumnName = "StudyStatusID")
    @ManyToOne(optional = false, fetch = FetchType.LAZY)
    @XmlElement
    private StudyStatus studyStatus;

    public Comment() {
    }

    public Integer getCommentsID() {
        return commentsID;
    }

    public void setCommentsID(Integer commentsID) {
        this.commentsID = commentsID;
    }

     public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public String getHyperText() {
        return hyperText;
    }

    public void setHyperText(String hyperText) {
        this.hyperText = hyperText;
    }

    public boolean getPublished() {
        return published;
    }

    public void setPublished(boolean published) {
        this.published = published;
    }

    public boolean getRedFlagged() {
        return redFlagged;
    }

    public void setRedFlagged(boolean redFlagged) {
        this.redFlagged = redFlagged;
    }

    public Date getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Date createdAt) {
        this.createdAt = createdAt;
    }

    @XmlTransient
    public StudyStatus getStudyStatus() {
        return studyStatus;
    }

    public void setStudyStatus(StudyStatus studyStatus) {
        this.studyStatus = studyStatus;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (commentsID != null ? commentsID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Comment)) {
            return false;
        }
        Comment other = (Comment) object;
        if ((this.commentsID == null && other.commentsID != null) || (this.commentsID != null && !this.commentsID.equals(other.commentsID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.va.rams.entities.Comment[ commentsID=" + commentsID + " ]";
    }

    public Integer getFormsID() {
        return formsID;
    }

    public void setFormsID(Integer formsID) {
        this.formsID = formsID;
    }

    public Integer getQuestionsID() {
        return questionsID;
    }

    public void setQuestionsID(Integer questionsID) {
        this.questionsID = questionsID;
    }

    public Integer getAnswersID() {
        return answersID;
    }

    public void setAnswersID(Integer answersID) {
        this.answersID = answersID;
    }
    
}
