package gov.va.rams.entities;

import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author Brian
 */
@Entity
@Table(name = "Users")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "User.findAll", query = "SELECT u FROM User u"),
    @NamedQuery(name = "User.findByUsersID", query = "SELECT u FROM User u WHERE u.usersID = :usersID"),
    @NamedQuery(name = "User.findByLoginName", query = "SELECT u FROM User u WHERE u.loginName = :loginName"),
    @NamedQuery(name = "User.findByPermanentLoginIdentifier", query = "SELECT u FROM User u WHERE u.permanentLoginIdentifier = :permanentLoginIdentifier")})
public class User implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer usersID;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 50)
    @Column(nullable = false, length = 50)
    private String loginName;
    @Basic
    @Size(min = 1, max = 100)
    @Column(length = 100)
    private String permanentLoginIdentifier;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 100)
    @Column(nullable = false, length = 100)
    private String displayName;
    @Basic
    @Column
    @Temporal(TemporalType.TIMESTAMP)
    private Date synchronizedTimestamp;
    @Basic
    @Column
    private Integer spUser;
    @OneToMany(fetch = FetchType.LAZY, mappedBy = "user")
    private Collection<Study_Members> studyMembersCollection;

    public User() {
    }

    public Integer getUsersID() {
        return usersID;
    }

    public void setUsersID(Integer usersID) {
        this.usersID = usersID;
    }
    
    public Integer getSPUser() {
        return spUser;
    }
    
    public void setSPUser(Integer spUser) {
        this.spUser = spUser;
    }

    public String getLoginName() {
        return loginName;
    }

    public void setLoginName(String loginName) {
        this.loginName = loginName;
    }

    public String getPermanentLoginIdentifier() {
        return permanentLoginIdentifier;
    }

    public void setPermanentLoginIdentifier(String permanentLoginIdentifier) {
        this.permanentLoginIdentifier = permanentLoginIdentifier;
    }

    public String getDisplayName() {
        return displayName;
    }

    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }

    public Date getSynchronizedTimestamp() {
        return synchronizedTimestamp;
    }

    public void setSynchronizedTimestamp(Date synchronizedTimestamp) {
        this.synchronizedTimestamp = synchronizedTimestamp;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (usersID != null ? usersID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof User)) {
            return false;
        }
        User other = (User) object;
        if ((this.usersID == null && other.usersID != null) || (this.usersID != null && !this.usersID.equals(other.usersID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.va.rams.User[ usersID=" + usersID + " loginName=" + loginName + " displayName=" + displayName + " permanentLoginIdentifier" + permanentLoginIdentifier + " studyMembersCollection=" + studyMembersCollection + " ]";
    }

    @XmlTransient
    public Collection<Study_Members> getStudyMembersCollection() {
        return studyMembersCollection;
    }

    public void setStudyMembersCollection(Collection<Study_Members> studyMembersCollection) {
        this.studyMembersCollection = studyMembersCollection;
    }
}
