package gov.va.rams.service;

import java.util.Set;
import javax.ws.rs.ApplicationPath;
import javax.ws.rs.Consumes;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Application;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.ext.Provider;
import org.eclipse.persistence.jaxb.rs.MOXyJsonProvider;

/**
 *
 * @author Brian
 */
@ApplicationPath("")
public class ApplicationConfig extends Application {

    @Override
    public Set<Class<?>> getClasses() {
        Set<Class<?>> resources = new java.util.HashSet<>();
        // XXX NetBeans 8.0.1 adding Maven dependencies as resources errantly;
        //     the legitimate set of resources get added in this method and
        //     the automatically-generated method never gets called.
        // addRestResourceClasses(resources);
        resources.add(gov.va.rams.service.ManageServiceREST.class);
        resources.add(gov.va.rams.service.MockServiceREST.class);
        resources.add(gov.va.rams.service.ServiceREST.class);
        return resources;
    }
    
    @Provider
    @Produces({MediaType.APPLICATION_JSON})
    @Consumes({MediaType.APPLICATION_JSON})
    public static class JSON extends MOXyJsonProvider {
        public JSON() {
            super();
            setIncludeRoot(false);
            setMarshalEmptyCollections(true);
        }
    }

    /**
     * Do not modify addRestResourceClasses() method.
     * It is automatically populated with
     * all resources defined in the project.
     * If required, comment out calling this method in getClasses().
     */
    private void addRestResourceClasses(Set<Class<?>> resources) {
        resources.add(gov.va.rams.service.ApplicationConfig.JSON.class);
        resources.add(gov.va.rams.service.ManageServiceREST.class);
        resources.add(gov.va.rams.service.MockServiceREST.class);
        resources.add(gov.va.rams.service.ServiceREST.class);
    }
}
