package gov.va.rams.utility;

import org.apache.commons.codec.binary.Base64;
//import java.util.Base64;

public class PasswordHelper {
    private static final String ENCODE = "ENCODE";
    private static final String DECODE = "DECODE";

    public static void main(String[] args) {
        String userName = "";
        String encodedSalt = "";
        String encodedPassword = "";
        String password = "";
        String action = "";
        int errors = 0;

        if (args.length == 3) {
            action = args[0].toUpperCase();
            if (action.equals(ENCODE) || action.equals(DECODE)) {
                System.out.println("action: " + action);
            } else {
                System.out.println("ERROR: Unknown action: " + action);
                errors += 1;
            }
            if (errors == 0) {
                if (action.equals(ENCODE)) {
                    userName = args[1];
                    if (args[2].length() > 0) {
                        password = args[2];
                    } else {
                        System.out.println("ERROR: Missing password: ");
                        errors += 1;
                    }
                } else if (action.equals(DECODE)) {
                    userName = args[1];
                    if (args[2].length() > 0) {
                        encodedPassword = args[2];
                    } else {
                        System.out.println("ERROR: Missing encoded password: ");
                        errors += 1;
                    }
                }
            }
        } else {
            System.out.println("ERROR: expected 3 parameters [ENCODE|DECODE] userName [password|encodedPassword]");
        }

        if (action.equals(ENCODE)) {
            System.out.println("Encoding username + password: " + userName + " " + password);
            encodedSalt = Base64.encodeBase64String(userName.getBytes());
            encodedPassword = Base64.encodeBase64String(password.getBytes());
            encodedPassword = encodedSalt + encodedPassword;
            System.out.println("encoded password: " + encodedPassword);
        } else if (action.equals(DECODE)) {
            System.out.println("Decoding username + encoded password: " + userName + " " + encodedPassword);
            String cipher = encodedPassword.substring(encodedPassword.indexOf("=") + 1);
            //System.out.println("cipher: " + cipher);
            byte[] passwordBytes = Base64.decodeBase64(cipher);
            password = new String(passwordBytes);
            System.out.println("password: " + password);
        }

        return;
    }

}
