package RAMS.RAMSPasswordHelper;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

public class PasswordHelperTest {

	@Before
	public void setUp() throws Exception {
	}

	@Test
	public void testMainEncode() {
		String[] args = {"ENCODE", "vhamaster\\someuser", "password"};
		PasswordHelper.main(args);
		assertTrue("Verify the Console output is correct", true);
	}

	@Test
	public void testMainDecode() {
		String[] args = {"DECODE", "vhamaster\\someuser", "dmhhbWFzdGVyXHNvbWV1c2VycGFzc3dvcmQ="};
		PasswordHelper.main(args);
		assertTrue("Verify the Console output is correct", true);
	}

	@Test
	public void testMainEncrypt() {
		String[] args = {"ENCRYPT", "vhamaster\\someuser", "password"};
		PasswordHelper.main(args);
		assertTrue("Verify the Console output is correct", true);
	}

	@Test
	public void testMainDecrypt() {
		String[] args = {"DECRYPT", "vhamaster\\someuser", "xP1uOEW0jIP4vn5Cn6PaF9qyf1T+4pKE"};
		PasswordHelper.main(args);
		assertTrue("Verify the Console output is correct", true);
	}

	@Test
	public void testEncode() {
		String userName = "vhamaster\\someuser";
		String password = "password";
		char[] er = new String("dmhhbWFzdGVyXHNvbWV1c2VycGFzc3dvcmQ=").toCharArray();
		char[] r = PasswordHelper.encodePassword(userName, password);
		assertArrayEquals("Error Encoding String", er, r);
	}

	@Test
	public void testDecode() {
		String userName = "vhamaster\\someuser";
		String encodedPassword = "dmhhbWFzdGVyXHNvbWV1c2VycGFzc3dvcmQ=";
		char[] er = new String("password").toCharArray();
		char[] r = PasswordHelper.decodePassword(userName, encodedPassword);
		assertArrayEquals("Error Encoding String", er, r);
	}

	@Test
	public void testEncrypt() {
		String userName = "vhamaster\\someuser";
		String password = "password";
		char[] er = new String("xP1uOEW0jIP4vn5Cn6PaF9qyf1T+4pKE").toCharArray();
		char[] r = PasswordHelper.encryptPassword(userName, password);
		assertNotSame("Error Encrypting/Decrypting String", password, r);
		assertNotEquals("Error Encrypting/Decrypting String", password, r);
	}

	@Test
	public void testDecrypt() {
		String userName = "vhamaster\\someuser";
		String password = "password";
		// password encryption can be different each time it is encrypted so we need to encrypt and then decrypt to test the decrypt
		char[] ep = PasswordHelper.encryptPassword(userName, password );
		String encryptedPassword = new String(ep);
		assertNotSame("Error Encrypting/Decrypting String", password, encryptedPassword);
		assertNotEquals("Error Encrypting/Decrypting String", password, encryptedPassword);
		char[] er = password.toCharArray();
		char[] r = PasswordHelper.decryptPassword(userName, encryptedPassword);
		assertArrayEquals("Error Decrypting String", er, r);
	}
}
