USE [RAMS]
GO

/****** Object:  View [dbo].[FundingAgencyStudyReport]    Script Date: 7/17/2017 8:30:58 AM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE VIEW [dbo].[FundingAgencyStudyReport]
AS
WITH CTE AS (SELECT        A.AssignedID, A.StudyStatesID, B.StudiesID, B.Title, C.Name
                               FROM            (SELECT        S.AssignedID, MAX(SS.StudyStatesID) AS StudyStatesID
                                                         FROM            dbo.Studies AS S INNER JOIN
                                                                                   dbo.Study_Status AS SS ON S.StudiesID = SS.StudiesID
                                                         GROUP BY S.AssignedID) AS A INNER JOIN
                                                         dbo.Studies AS B ON A.AssignedID = B.AssignedID INNER JOIN
                                                         dbo.Study_States AS C ON C.StudyStatesID = A.StudyStatesID), CTE2 AS
    (SELECT    distinct S.AssignedID, S.Title, convert(varchar(500),QR.Response) AS Response
      FROM            dbo.Studies AS S INNER JOIN
                                dbo.Study_Status AS SS ON S.StudiesID = SS.StudiesID INNER JOIN
                                dbo.Questions_Responses AS QR ON QR.StudyStatusID = SS.StudyStatusID
      WHERE        (QR.QuestionsID =13650)), CTE3 AS

	(SELECT        S.AssignedID, S.Title, QR.Response
      FROM            dbo.Studies AS S INNER JOIN
                                dbo.Study_Status AS SS ON S.StudiesID = SS.StudiesID INNER JOIN
                                dbo.Questions_Responses AS QR ON QR.StudyStatusID = SS.StudyStatusID
      WHERE        (QR.QuestionsID IN (14144)))


    SELECT        CTE_1.AssignedID as StudyID, CTE_1.Title, CTE_1.Name as Status, CTE2_1.Response AS FundingAgency, CTE_3.Response AS Facility
     FROM            CTE AS CTE_1 INNER JOIN
                              CTE2 AS CTE2_1 ON CTE_1.AssignedID = CTE2_1.AssignedID join CTE3 AS CTE_3 on CTE_1.AssignedID = CTE_3.AssignedID
GO




USE [RAMS]
GO

/****** Object:  View [dbo].[PIStudyReport]    Script Date: 7/17/2017 9:06:16 AM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE VIEW [dbo].[PIStudyReport]
AS
WITH CTE AS (SELECT        A.AssignedID, A.StudyStatesID, B.StudiesID, B.Title, C.Name
                               FROM            (SELECT        S.AssignedID, MAX(SS.StudyStatesID) AS StudyStatesID
                                                         FROM            dbo.Studies AS S INNER JOIN
                                                                                   dbo.Study_Status AS SS ON S.StudiesID = SS.StudiesID
                                                         GROUP BY S.AssignedID) AS A INNER JOIN
                                                         dbo.Studies AS B ON A.AssignedID = B.AssignedID INNER JOIN
                                                         dbo.Study_States AS C ON C.StudyStatesID = A.StudyStatesID), CTE2 AS
    (SELECT        S.AssignedID, S.Title, QR.Response
      FROM            dbo.Studies AS S INNER JOIN
                                dbo.Study_Status AS SS ON S.StudiesID = SS.StudiesID INNER JOIN
                                dbo.Questions_Responses AS QR ON QR.StudyStatusID = SS.StudyStatusID
      WHERE        (QR.QuestionsID IN (13447, 13784))), CTE3 AS

	(SELECT        S.AssignedID, S.Title, QR.Response
      FROM            dbo.Studies AS S INNER JOIN
                                dbo.Study_Status AS SS ON S.StudiesID = SS.StudiesID INNER JOIN
                                dbo.Questions_Responses AS QR ON QR.StudyStatusID = SS.StudyStatusID
      WHERE        (QR.QuestionsID IN (14144)))


    SELECT        CTE_1.AssignedID as StudyID, CTE_1.Title, CTE_1.Name as Status, CTE2_1.Response AS PI, CTE_3.Response AS Facility
     FROM            CTE AS CTE_1 INNER JOIN
                              CTE2 AS CTE2_1 ON CTE_1.AssignedID = CTE2_1.AssignedID join CTE3 AS CTE_3 on CTE_1.AssignedID = CTE_3.AssignedID
GO


