USE [RAMS]
GO

/****** Object:  StoredProcedure [dbo].[StudyStateCountsReport]    Script Date: 7/17/2017 9:07:41 AM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

create procedure [dbo].[StudyStateCountsReport]
(@Facility varchar(100))
AS

BEGIN
with CTE 
AS
(select SS.StudiesID, SS.UpdatedAt, SS.StudystatesID,S.Name
FROM Study_Status SS
 inner join (Select StudiesID, MAX(UpdatedAt) as MaxStudyDate
				FROM Study_Status
				GROUP BY StudiesID) A
ON SS.StudiesID = A.StudiesID 
join Study_States S on SS.StudyStatesID = S.StudyStatesID
AND SS.UpdatedAt = A.MaxStudyDate) , CTE2 AS

(SELECT        S.StudiesID, QR.Response
      FROM            dbo.Studies AS S INNER JOIN
                                dbo.Study_Status AS SS ON S.StudiesID = SS.StudiesID INNER JOIN
                                dbo.Questions_Responses AS QR ON QR.StudyStatusID = SS.StudyStatusID
      WHERE        (QR.QuestionsID IN (14144)))

SELECT CTE1.Name, count(*) As NumberOfStudies
FROM CTE AS CTE1 join CTE2 on CTE1.StudiesID = CTE2.StudiesID
WHERE CTE2.Response like @Facility and CTE1.UpdatedAt > getdate() - 365
GROUP BY CTE1.Name

END
GO


