USE [RAMS]
GO
/****** Object:  StoredProcedure [dbo].[StudyTypeReport]    Script Date: 7/18/2017 11:22:39 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE procedure [dbo].[StudyTypeReport] (
@Facility varchar(100))
AS

BEGIN

	--Create Temp table
	create table #StudyCommittee (
	StudyID char(15),
	Title	varchar(200),
	StudyStatus varchar(10),
	PIName	varchar(100),
	Facility varchar(100),
	Human varchar(3),
	Animal varchar(3),
	[Safety] varchar(3))

	--Insert base records
	insert into #StudyCommittee (StudyID, Title, StudyStatus, PIName, Facility)
	select * from [PIStudyReport]
	where convert(varchar(100),Facility) = @Facility

	--Set all Human studies to 'YES'
	update #StudyCommittee 
	set Human = 'YES'

	update #StudyCommittee 
	set Animal = 'NO'
	--Set all IACUC studies to 'YES'
	update #StudyCommittee 
	set Animal = 'YES'
	where #StudyCommittee.StudyID in (
	select S.AssignedID
	from [Questions_Responses] QR join [dbo].[Study_Status] SS on QR.StudyStatusID = SS.StudyStatusID join Studies S on SS.StudiesID = S.StudiesID
	where QR.QuestionsID = (select questionsID from questions where [QuestionHyperText] like 'Does this project involve animal subjects%'))

	update #StudyCommittee 
	set [Safety] = 'NO'
	--Set all SRS studies to 'YES'
	update #StudyCommittee 
	set [Safety] = 'YES'
	where #StudyCommittee.StudyID in (
	select S.AssignedID--, A.Value
	from [Questions_Responses] QR join [dbo].[Study_Status] SS on QR.StudyStatusID = SS.StudyStatusID join Studies S on SS.StudiesID = S.StudiesID
	join Answers A on QR.AnswersID = A.AnswersID 
	where QR.QuestionsID in (
		select questionsID from questions where [QuestionHyperText] like 'Does the research involve a collection of specimens from human subjects%'
		or [QuestionHyperText] like 'Does the research involve the use of X-rays, radioisotopes, or Ionizing Radiation Source%'
		or [QuestionHyperText] like 'Does the research involve the use of investigational drugs or biologics%'
		or [QuestionHyperText] like 'Does the research involve the use of devices%'
		or [QuestionHyperText] like 'Does the research involve the use of biohazards%'
		or [QuestionHyperText] like 'Does the research involve the use of recombinant DNA, human gene transfer, xenotransplantation, or investigational%'
	)
	and A.Value = 'Yes')

	--Set all IRB to No that qualify for 'Exempt'
	update #StudyCommittee 
	set [Human] = 'NO'
	where #StudyCommittee.StudyID in (
	select S.AssignedID--, A.Value
	from [Questions_Responses] QR join [dbo].[Study_Status] SS on QR.StudyStatusID = SS.StudyStatusID join Studies S on SS.StudiesID = S.StudiesID
	join Answers A on QR.AnswersID = A.AnswersID 
	where QR.QuestionsID in (
	select questionsID from questions where [QuestionHyperText] like 'Do you believe your study qualifies for exempt, expedited or full board review%'
	)
	and A.Value = 'Exempt')


	select * from #StudyCommittee
	drop table #StudyCommittee

END



