use [RAMS]
GO

insert into [dbo].[Questions]( QuestionHyperText, OtherOptionHyperText, HelpHyperText, ResponseFormatsID)
values('Has your participation in this project and that of your project team been reviewed by your local Conflict of Interest Committee or in accordance with your local conflict of interest policies and procedures?',NULL,NULL,2)

declare @questionID0 int,
@AnswersID0 int
select @questionID0 = QuestionsID
from Questions 
where questionHyperText like 'Has your participation in this project and that of your project team been reviewed by your local Conflict of Interest Committee or in%'

insert into [dbo].[Forms_Questions]( FormsID, QuestionsID, FormSequencePosition, RequiredPredecessorAnswersID, RequiredPredecessorQuestionsID)
values(483,@questionID0,20,NULL,NULL)

insert into [dbo].[Answers]( QuestionsID, Value, SequencePosition)
values(@questionID0,'Yes. The determinations of my local Conflict of Interest Committee or other local Conflict of Interest review are attached.',1)
insert into [dbo].[Answers]( QuestionsID, Value, SequencePosition)
values(@questionID0,'Review is pending. Determinations will be forwarded upon completion of review. I understand no final decision regarding approval of this project can be made until the local Conflict of Interest Committee determinations have been received.',2)
insert into [dbo].[Answers]( QuestionsID, Value, SequencePosition)
values(@questionID0,'There is no mechanism at our local site for doing the COI review. Copies of completed OGE Forms 450 for all study team members serving in an Investigator role are attached.',3);



SET IDENTITY_INSERT [Response_Formats] ON;
insert into [dbo].[Response_Formats](ResponseFormatsID, Name)
values(10,'Facility');
SET IDENTITY_INSERT [Response_Formats] OFF;

declare @questionsID int

insert into questions (QuestionHyperText, ResponseFormatsID)
values ('Select Facility name from dropdown list',10)

select @questionsId = questionsID
from questions 
where QuestionHyperText like '%Select Facility name from dropdown list%'

insert into Forms_Questions(FormsID, QuestionsID, FormSequencePosition)
values(481,@questionsId,7);

USE [RAMS]
GO

/****** Object:  View [dbo].[FundingAgencyStudyReport]    Script Date: 7/17/2017 8:30:58 AM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


CREATE VIEW [dbo].[FundingAgencyStudyReport]
AS
WITH CTE AS (SELECT        A.AssignedID, A.StudyStatesID, B.StudiesID, B.Title, C.Name
                               FROM            (SELECT        S.AssignedID, MAX(SS.StudyStatesID) AS StudyStatesID
                                                         FROM            dbo.Studies AS S INNER JOIN
                                                                                   dbo.Study_Status AS SS ON S.StudiesID = SS.StudiesID
                                                         GROUP BY S.AssignedID) AS A INNER JOIN
                                                         dbo.Studies AS B ON A.AssignedID = B.AssignedID INNER JOIN
                                                         dbo.Study_States AS C ON C.StudyStatesID = A.StudyStatesID), CTE2 AS
    (SELECT    distinct S.AssignedID, S.Title, A.Value AS Response
      FROM            dbo.Studies AS S INNER JOIN
                                dbo.Study_Status AS SS ON S.StudiesID = SS.StudiesID INNER JOIN
                                dbo.Questions_Responses AS QR ON QR.StudyStatusID = SS.StudyStatusID
								inner join Answers A on A.AnswersID = QR.AnswersID
      WHERE        (QR.QuestionsID =13650)), CTE3 AS

	(SELECT        S.AssignedID, S.Title, QR.Response
      FROM            dbo.Studies AS S INNER JOIN
                                dbo.Study_Status AS SS ON S.StudiesID = SS.StudiesID INNER JOIN
                                dbo.Questions_Responses AS QR ON QR.StudyStatusID = SS.StudyStatusID
      WHERE        (QR.QuestionsID IN (14144)))


    SELECT        CTE_1.AssignedID as StudyID, CTE_1.Title, CTE_1.Name as Status, CTE2_1.Response AS FundingAgency, CTE_3.Response AS Facility
     FROM            CTE AS CTE_1 INNER JOIN
                              CTE2 AS CTE2_1 ON CTE_1.AssignedID = CTE2_1.AssignedID join CTE3 AS CTE_3 on CTE_1.AssignedID = CTE_3.AssignedID

GO




USE [RAMS]
GO

/****** Object:  View [dbo].[PIStudyReport]    Script Date: 7/17/2017 9:06:16 AM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE VIEW [dbo].[PIStudyReport]
AS
WITH CTE AS (SELECT        A.AssignedID, A.StudyStatesID, B.StudiesID, B.Title, C.Name
                               FROM            (SELECT        S.AssignedID, MAX(SS.StudyStatesID) AS StudyStatesID
                                                         FROM            dbo.Studies AS S INNER JOIN
                                                                                   dbo.Study_Status AS SS ON S.StudiesID = SS.StudiesID
                                                         GROUP BY S.AssignedID) AS A INNER JOIN
                                                         dbo.Studies AS B ON A.AssignedID = B.AssignedID INNER JOIN
                                                         dbo.Study_States AS C ON C.StudyStatesID = A.StudyStatesID), CTE2 AS
    (SELECT        S.AssignedID, S.Title, QR.Response
      FROM            dbo.Studies AS S INNER JOIN
                                dbo.Study_Status AS SS ON S.StudiesID = SS.StudiesID INNER JOIN
                                dbo.Questions_Responses AS QR ON QR.StudyStatusID = SS.StudyStatusID
      WHERE        (QR.QuestionsID IN (13447, 13784))), CTE3 AS

	(SELECT        S.AssignedID, S.Title, QR.Response
      FROM            dbo.Studies AS S INNER JOIN
                                dbo.Study_Status AS SS ON S.StudiesID = SS.StudiesID INNER JOIN
                                dbo.Questions_Responses AS QR ON QR.StudyStatusID = SS.StudyStatusID
      WHERE        (QR.QuestionsID IN (14144)))


    SELECT        CTE_1.AssignedID as StudyID, CTE_1.Title, CTE_1.Name as Status, CTE2_1.Response AS PI, CTE_3.Response AS Facility
     FROM            CTE AS CTE_1 INNER JOIN
                              CTE2 AS CTE2_1 ON CTE_1.AssignedID = CTE2_1.AssignedID join CTE3 AS CTE_3 on CTE_1.AssignedID = CTE_3.AssignedID
GO


USE [RAMS]
GO

/****** Object:  StoredProcedure [dbo].[StudyStateCountsReport]    Script Date: 7/17/2017 9:07:41 AM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

create procedure [dbo].[StudyStateCountsReport]
(@Facility varchar(100))
AS

BEGIN
with CTE 
AS
(select SS.StudiesID, SS.UpdatedAt, SS.StudystatesID,S.Name
FROM Study_Status SS
 inner join (Select StudiesID, MAX(UpdatedAt) as MaxStudyDate
				FROM Study_Status
				GROUP BY StudiesID) A
ON SS.StudiesID = A.StudiesID 
join Study_States S on SS.StudyStatesID = S.StudyStatesID
AND SS.UpdatedAt = A.MaxStudyDate) , CTE2 AS

(SELECT        S.StudiesID, QR.Response
      FROM            dbo.Studies AS S INNER JOIN
                                dbo.Study_Status AS SS ON S.StudiesID = SS.StudiesID INNER JOIN
                                dbo.Questions_Responses AS QR ON QR.StudyStatusID = SS.StudyStatusID
      WHERE        (QR.QuestionsID IN (14144)))

SELECT CTE1.Name, count(*) As NumberOfStudies
FROM CTE AS CTE1 join CTE2 on CTE1.StudiesID = CTE2.StudiesID
WHERE CTE2.Response like @Facility and CTE1.UpdatedAt > getdate() - 365
GROUP BY CTE1.Name

END
GO

USE [RAMS]
GO
/****** Object:  StoredProcedure [dbo].[StudyTypeReport]    Script Date: 7/18/2017 11:22:39 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE procedure [dbo].[StudyTypeReport] (
@Facility varchar(100))
AS

BEGIN

	--Create Temp table
	create table #StudyCommittee (
	StudyID char(15),
	Title	varchar(200),
	StudyStatus varchar(10),
	PIName	varchar(100),
	Facility varchar(100),
	Human varchar(3),
	Animal varchar(3),
	[Safety] varchar(3))

	--Insert base records
	insert into #StudyCommittee (StudyID, Title, StudyStatus, PIName, Facility)
	select * from [PIStudyReport]
	where convert(varchar(100),Facility) = @Facility

	--Set all Human studies to 'YES'
	update #StudyCommittee 
	set Human = 'YES'

	update #StudyCommittee 
	set Animal = 'NO'
	--Set all IACUC studies to 'YES'
	update #StudyCommittee 
	set Animal = 'YES'
	where #StudyCommittee.StudyID in (
	select S.AssignedID
	from [Questions_Responses] QR join [dbo].[Study_Status] SS on QR.StudyStatusID = SS.StudyStatusID join Studies S on SS.StudiesID = S.StudiesID
	where QR.QuestionsID = (select questionsID from questions where [QuestionHyperText] like 'Does this project involve animal subjects%') and QR.AnswersID = 14344 )

	update #StudyCommittee 
	set [Safety] = 'NO'
	--Set all SRS studies to 'YES'
	update #StudyCommittee 
	set [Safety] = 'YES'
	where #StudyCommittee.StudyID in (
	select S.AssignedID--, A.Value
	from [Questions_Responses] QR join [dbo].[Study_Status] SS on QR.StudyStatusID = SS.StudyStatusID join Studies S on SS.StudiesID = S.StudiesID
	join Answers A on QR.AnswersID = A.AnswersID 
	where QR.QuestionsID in (
		select questionsID from questions where [QuestionHyperText] like 'Does the research involve a collection of specimens from human subjects%'
		or [QuestionHyperText] like 'Does the research involve the use of X-rays, radioisotopes, or Ionizing Radiation Source%'
		or [QuestionHyperText] like 'Does the research involve the use of investigational drugs or biologics%'
		or [QuestionHyperText] like 'Does the research involve the use of devices%'
		or [QuestionHyperText] like 'Does the research involve the use of biohazards%'
		or [QuestionHyperText] like 'Does the research involve the use of recombinant DNA, human gene transfer, xenotransplantation, or investigational%'
	)
	and A.Value = 'Yes')

	--Set all IRB to No that qualify for 'Exempt'
	update #StudyCommittee 
	set [Human] = 'NO'
	where #StudyCommittee.StudyID in (
	select S.AssignedID--, A.Value
	from [Questions_Responses] QR join [dbo].[Study_Status] SS on QR.StudyStatusID = SS.StudyStatusID join Studies S on SS.StudiesID = S.StudiesID
	join Answers A on QR.AnswersID = A.AnswersID 
	where QR.QuestionsID in (
	select questionsID from questions where [QuestionHyperText] like 'Do you believe your study qualifies for exempt, expedited or full board review%'
	)
	and A.Value = 'Exempt')


	select * from #StudyCommittee
	drop table #StudyCommittee

END





