/*
Note: Modify the location path in two places within the script to reflect the proper location of the following items:
	Current location of backup file shown as N'D:\2-0_Backups\RAMS_Prod_Full.bak'  (Make sure to select correct location in 'TO  DISK' line).
	current location of backup file shown as N'D:\2-0_Backups\RAMS_Prod_Full.bak'. (in 'RESTORE VERIFYONLY FROM  DISK ' line)
*/

BACKUP DATABASE [RAMS] 
TO  DISK = N'D:\2-0_Backups\RAMS_Prod_Full.bak' 
WITH  DESCRIPTION = N'RAMS Prod Full Backup Before DB Refresh', NOFORMAT, NOINIT,  
NAME = N'RAMS-Full Database Backup', SKIP, NOREWIND, NOUNLOAD,  STATS = 10
GO
declare @backupSetId as int
select @backupSetId = position from msdb..backupset 
where database_name=N'RAMS' and backup_set_id=(select max(backup_set_id) from msdb..backupset where database_name=N'RAMS' )
if @backupSetId is null begin raiserror(N'Verify failed. Backup information for database ''RAMS'' not found.', 16, 1) end
RESTORE VERIFYONLY FROM  DISK = N'D:\2-0_Backups\RAMS_Prod_Full.bak' WITH  FILE = @backupSetId,  NOUNLOAD,  NOREWIND
GO
