var protocol = "https://";
var port = "PORT";

	/*
	Please update the below server with the correct server name
	Replace the server name with these values by uncommenting the server name needed for the environment and commenting the server names not needed.
	DEV:  
	reportsServerName=vaww.rpt.idev.ram.msp.DNS   
	TEST:  
	reportsServerName=vaww.rpt.itst.ram.msp.DNS   
	SQA:  
	reportsServerName=vaww.rpt.itst.ram.msp.DNS   
	Pre-prod:  
	reportsServerName=Unknown	
	Prod:  
	reportsServerName=Unknown	
	*/

var reportsServerName="";
var mySitesServerName="";

var RAMSApp = "RAMS-2.1.0";
var env = window.location.hostname;
var siteCollection="/sites/IRBApplications/";

var dynamicSharepointURL="";
var dynamicWebServiceURL="";

var dynamicReportURL="";

if ( (env.indexOf("idev") != -1)  ||  (env.indexOf("itst") != -1) )  {
	protocol="https://";
	port="PORT";
	dynamicSharepointURL = protocol + env + siteCollection;
	dynamicWebServiceURL = protocol + env + ":" + port + "/" + RAMSApp + "/";
}
else {
	dynamicSharepointURL = protocol + env + siteCollection;
	dynamicWebServiceURL = protocol + env + ":" + port + "/" + RAMSApp + "/";
}

	
if (env.indexOf("idev") != -1)  {
	reportsServerName="vaww.rpt.idev.ram.msp.DNS   ";
	mySitesServerName=protocol + "vaww.mysites.idev.ram.msp.DNS   ";
} else if (env.indexOf("itst") != -1) {
	reportsServerName="vaww.rpt.itst.ram.msp.DNS   ";
	mySitesServerName=protocol + "vaww.mysites.itst.ram.msp.DNS   ";
} else if (env.indexOf("sqa") != -1) {
	reportsServerName="vaww.rpt.sqa.ram.msp.DNS   ";
	mySitesServerName=protocol +"vaww.mysites.sqa.ram.msp.DNS   ";
} else if (env.indexOf("ppd") != -1) {
	reportsServerName="vaww.rpt.ppd.ram.msp.DNS   ";
	mySitesServerName=protocol +"vaww.mysites.ppd.ram.msp.DNS   ";
} else {
	reportsServerName="vaww.rpt.ram.msp.DNS   ";
	mySitesServerName=protocol + "vaww.mysites.ram.msp.DNS   ";

}

dynamicReportURL= protocol + reportsServerName + "/Reports/Pages/Folder.aspx?ItemPath=%2fRAMS+Reports&ViewMode=List";
	
	
// Define environmental constants for RAMS web-apps.
window.RAMS = window.RAMS || {};
RAMS.Environment = {
	SharePoint: {
		//dev and test site
		//URL: "http://" + window.location.hostname + "/sites/IRBApplications/",
		
		//SQA site
		URL: dynamicSharepointURL,
		CentralIRBSite: "Central IRB",
		List: {} // Column mappings defined below.
	},
	WebService: {
		
		//dev and test site
		//URL: "http://" + window.location.hostname + ":8889/RAMS-2.1.0/"
		
		//SQA site
		URL: dynamicWebServiceURL
		// Form mappings defined below.
	},
	Reports: {
		URL: dynamicReportURL
	}
	
};


  //////////////////
 // REPLACE HERE //
//////////////////
RAMS.Environment.SharePoint.List.Application = {
	FacilityLookupId: 			"FacilityLookupId",
	SiteLookupId: 			    "SiteLookupId",
	LinkToApplication: 			"LinktoApplication",
	PrincipalInvestigatorId:	"PrincipalInvestigatorId",
    CoPrincipalInvestigatorId:	"CoPIId",
	PrimaryReviewersId:			"PrimaryReviewersId"
};

RAMS.Environment.WebService.Form = {
	Parent: 53,					53: "Parent",
	Local: 54,					54: "Local",
	Adverse: 55,				55: "Adverse",
	ContReview: 56,				56: "ContReview",
	Closeout: 57,				57: "Closeout",
	AdministrativeUpdate: 58,	58: "AdministrativeUpdate"
};
  //////////////////
 // REPLACE HERE //
//////////////////
