$(document).ready(changeCommitteeLink());

function changeCommitteeLink() {
	var potentialGroups = {};
	var isMember = function(gid) {
		return potentialGroups[gid];
	};
	var currentUrl = RAMS.Environment.SharePoint.URL;

	restCall(currentUrl + "_api/Web/CurrentUser/Groups", function(returnedGroups) {
		var i;
		returnedGroups = returnedGroups.d.results;

		for (i = 0; i < returnedGroups.length; i++)
			potentialGroups[returnedGroups[i].Id] = true;
		//should only be assinged to one Users groups
		restCall(currentUrl + "_api/Web/lists/GetByTitle('Committee List')/Items", function(committees) {
			var c, matches = [];
			committees = committees.d.results;

			for (i = 0; i < committees.length; i++) {
				c = committees[i];
				if (isMember(c.CommitteeCoordinatorsId) ||
				    isMember(c.CommitteeMembersId) ||
				    isMember(c.IRBAdministratorsId) ||
				    isMember(c.LocalSiteAdministratorsId) ||
				    isMember(c.LocalSiteLiaisonsId) ||
				    isMember(c.UsersId))
					matches.push(c);
			}
			var facilityLookup="";
			if (matches.length == 1) {
				facilityLookup = matches[0].CommitteeSub_x002d_Site.Url;
				facilityLookup=(facilityLookup.substr(facilityLookup.lastIndexOf('/') + 1));
				var facilitySite="../SitePages/FacilityHome.html?facilityName=" + facilityLookup;
				window.location.replace(facilitySite);
			} else if (matches.length == 0) {
				$(document.body).append("<em>You are not a member of any of the site groups in the Committee List.</em>");
			} else {
				$(document.body).append("<p><em>You are a group member within several sites on the Committee List:</em></p>");
				for (i = 0; i < matches.length; i++)
				facilityLookup = matches[i].CommitteeSub_x002d_Site.Url;
				facilityLookup=(facilityLookup.substr(facilityLookup.lastIndexOf('/') + 1));
				$(document.body).append("<a href='" + "../SitePages/FacilityHome.html?facilityName=" + facilityLookup  + "'>" + matches[i].Title + "</a><br/>");
			}
		});
	});
}

function restCall(endpoint, callback){
	jQuery.ajax({
		url: endpoint,
		type: "GET",
		headers: {
			"accept": "application/json; odata=verbose"
		}
	}).done(function(returnedJson){
		callback(returnedJson);
	});
}
